
package de.ivu.elect.business.benutzerverwaltung.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.benutzerverwaltung.entity.Nachricht;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractNachrichtEdit {

  @Inject
  protected NachrichtDAO dao;

  @Inject
  protected NachrichtExtendedDAO extendedDao;

  public void delete(Nachricht entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Nachricht entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Nachricht entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Nachricht getAttachedEntity(Nachricht entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Nachricht getAttachedAndRefreshedEntity(Nachricht entity) {
    return dao.refresh(entity);
  }
}
